# Latest commit on Dec 20 2015: 5ad7cd5 - preparing tarball:
# git clone https://github.com/gordboy/rtl8812au.git rtl8812au-driver-5.2.20.2
# git archive --prefix=rtl8812au-5.2.20.2/ --format=tar HEAD | xz -9 > ../rtl8812au-5.2.20.2.tar.xz
# git clone -b v5.7.0 https://github.com/aircrack-ng/rtl8812au.git
# named source rtl88xxau-5.7.0.tar.xz
%global srcmod	rtl8812au
%global	module	88xxau
%global pname rtl%{module}
%define bversion 5.6.4.2

Name:		dkms-%{pname}
Version:	5.7.0
Release:	%mkrel 7
Source0:	%{pname}-%{bversion}.tar.xz

Patch0:		rtl88xxau-makefile8.patch
Patch1:		rtl88xxau-5.6.4.2-remove-double-defined-in-usb_inf.c.patch
Patch2:     rtl88xxau-kernel-5.10.patch

License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/aircrack-ng/rtl8812au.git
Summary:	dkms package for realtek 8812/14/21au driver
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Provides:	%{name}-%{version}
Requires: 	kernel
Requires:   gcc >= 10.2.0
Requires(post):		dkms
Requires(preun):	dkms

Obsoletes:	%{name} < %{version}-%{release}


%description
Important!
* Use "ip" and "iw" instead of "ifconfig" and "iwconfig"
     It's described further down, READ THE README!
* v5.3.4 is the stable branch, not this, but this does have
  better range then branches below + more fixes from Realtek

LED control:
statically by module parameter in /etc/modprobe.d/8812au.conf or wherever,
for example:  options rtl88xxau rtw_led_ctrl=0

value can be 0 or 1
or dynamically by writing to /proc/net/rtl8812au/$(your interface name)/led_ctrl,
for example:
$ echo "0" > /proc/net/rtl8812au/$(your interface name)/led_ctrl

value can be 0 or 1
check current value:

$ cat /proc/net/rtl8812au/$(your interface name)/led_ctrl

USB Mode Switch:
0: doesn't switch, 1: switch from usb2.0 to usb 3.0 2: switch from usb3.0 to usb 2.0
$ rmmod rtl88xxau
$ modprobe rtl88xxau rtw_switch_usb_mode:int
(0: no switch 1: switch from usb2 to usb3 2: switch from usb3 to usb2)

Realtek released a new multichip 'base', the v5.6.4.2 which supports kernel v5.3+
and they fixed the P2P NoA potentially buffer overflow.(See ReleaseNotes.pdf)
supports:
* Monitor mode
* Frame injection
* MESH Mode (IBSS)
* WPA3 SAE
* Wi-Fi Direct
* wpa_supplicant
* Hostapd
* USB 3.0 (currently forced down to 2)
* Kernel up to v5.3+

Realtek 88xxAU driver v5.6.4.2 with monitor mode and frame injection
This driver supports RTL8812AU/21AU and RTL8814AU chipsets wlan-only.
Supports Realtek 8812, 8814 and 8821 chipsets
*=== CONFIG_RTL8812A ===*
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8812), .driver_info = RTL8812}, /* Default ID */
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x881A), .driver_info = RTL8812}, /* Default ID */
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x881B), .driver_info = RTL8812}, /* Default ID */
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x881C), .driver_info = RTL8812}, /* Default ID */
	/*=== Customer ID ===*/
{USB_DEVICE(0x050D, 0x1106), .driver_info = RTL8812}, /* Belkin - sercomm */
{USB_DEVICE(0x7392, 0xA822), .driver_info = RTL8812}, /* Edimax - Edimax */
{USB_DEVICE(0x0DF6, 0x0074), .driver_info = RTL8812}, /* Sitecom - Edimax */
{USB_DEVICE(0x04BB, 0x0952), .driver_info = RTL8812}, /* I-O DATA - Edimax */
{USB_DEVICE(0x0789, 0x016E), .driver_info = RTL8812}, /* Logitec - Edimax */
{USB_DEVICE(0x0409, 0x0408), .driver_info = RTL8812}, /* NEC - */
{USB_DEVICE(0x0B05, 0x17D2), .driver_info = RTL8812}, /* ASUS - Edimax */
{USB_DEVICE(0x0E66, 0x0022), .driver_info = RTL8812}, /* HAWKING - Edimax */
{USB_DEVICE(0x0586, 0x3426), .driver_info = RTL8812}, /* ZyXEL - */
{USB_DEVICE(0x2001, 0x3313), .driver_info = RTL8812}, /* D-Link - ALPHA */
{USB_DEVICE(0x1058, 0x0632), .driver_info = RTL8812}, /* WD - Cybertan */
{USB_DEVICE(0x1740, 0x0100), .driver_info = RTL8812}, /* EnGenius - EnGenius */
{USB_DEVICE(0x2019, 0xAB30), .driver_info = RTL8812}, /* Planex - Abocom */
{USB_DEVICE(0x07B8, 0x8812), .driver_info = RTL8812}, /* Abocom - Abocom */
{USB_DEVICE(0x0846, 0x9051), .driver_info = RTL8812}, /* Netgear A6200 v2 */
{USB_DEVICE(0x2001, 0x330E), .driver_info = RTL8812}, /* D-Link - ALPHA */
{USB_DEVICE(0x2001, 0x3313), .driver_info = RTL8812}, /* D-Link - ALPHA */
{USB_DEVICE(0x2001, 0x3315), .driver_info = RTL8812}, /* D-Link - Cameo */
{USB_DEVICE(0x2001, 0x3316), .driver_info = RTL8812}, /* D-Link - Cameo */
{USB_DEVICE(0x13B1, 0x003F), .driver_info = RTL8812}, /* Linksys - WUSB6300 */
{USB_DEVICE(0x2357, 0x0101), .driver_info = RTL8812}, /* TP-Link - Archer T4U AC1200 */
{USB_DEVICE(0x2357, 0x0103), .driver_info = RTL8812}, /* TP-Link - T4UH */
{USB_DEVICE(0x2357, 0x010D), .driver_info = RTL8812}, /* TP-Link - Archer T4U AC1300 */
{USB_DEVICE(0x2357, 0x0115), .driver_info = RTL8812}, /* TP-Link - Archer T4U AC1300 */
{USB_DEVICE(0x2357, 0x010E), .driver_info = RTL8812}, /* TP-Link - Archer T4UH AC1300 */
{USB_DEVICE(0x2357, 0x010F), .driver_info = RTL8812}, /* TP-Link - T4UHP */
{USB_DEVICE(0x2357, 0x0122), .driver_info = RTL8812}, /* TP-Link - T4UHP (other) */
{USB_DEVICE(0x2357, 0x011F), .driver_info = RTL8812}, /* TP-Link - Archer AC600 T2U Nano */
{USB_DEVICE(0x20F4, 0x805B), .driver_info = RTL8812}, /* TRENDnet - */
{USB_DEVICE(0x0411, 0x025D), .driver_info = RTL8812}, /* Buffalo - WI-U3-866D */
{USB_DEVICE(0x050D, 0x1109), .driver_info = RTL8812}, /* Belkin F9L1109 - SerComm */
{USB_DEVICE(0x148F, 0x9097), .driver_info = RTL8812}, /* Amped Wireless ACA1 */
{USB_DEVICE(0x0BDA, 0x8812), .driver_info = RTL8812}, /* Alfa - AWUS036AC, AWUS036ACH & AWUS036EAC */
{USB_DEVICE(0x2604, 0x0012), .driver_info = RTL8812}, /* Tenda U12 */
{USB_DEVICE(0x0BDA, 0x881A), .driver_info = RTL8812}, /* Unex DAUK-W8812 */
*=== CONFIG_RTL8821A ===*
	/*=== Realtek demoboard ===*/
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x0811), .driver_info = RTL8821}, /* Default ID */
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x0821), .driver_info = RTL8821}, /* Default ID */
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8822), .driver_info = RTL8821}, /* Default ID */
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0xA811) , .driver_info = RTL8821},/* Default ID */
{USB_DEVICE_AND_INTERFACE_INFO(USB_VENDER_ID_REALTEK, 0x0820, 0xff, 0xff, 0xff),
 .driver_info = RTL8821}, /* 8821AU */
{USB_DEVICE_AND_INTERFACE_INFO(USB_VENDER_ID_REALTEK, 0x0823, 0xff, 0xff, 0xff),
 .driver_info = RTL8821}, /* 8821AU */
*=== Customer ID ===*
{USB_DEVICE(0x7392, 0xA811), .driver_info = RTL8821}, /* Edimax - Edimax */
{USB_DEVICE(0x7392, 0xA812), .driver_info = RTL8821}, /* Edimax - EW-7811UTC */
{USB_DEVICE(0x7392, 0xA813), .driver_info = RTL8821}, /* Edimax - EW-7811UAC */
{USB_DEVICE(0x04BB, 0x0953), .driver_info = RTL8821}, /* I-O DATA - Edimax */
{USB_DEVICE(0x2001, 0x3314), .driver_info = RTL8821}, /* D-Link - Cameo */
{USB_DEVICE(0x2001, 0x3318), .driver_info = RTL8821}, /* D-Link - Cameo */
{USB_DEVICE(0x0E66, 0x0023), .driver_info = RTL8821}, /* HAWKING - Edimax */
{USB_DEVICE(0x056E, 0x400E), .driver_info = RTL8821}, /* ELECOM -  ELECOM */
{USB_DEVICE(0x056E, 0x400F), .driver_info = RTL8821}, /* ELECOM -  ELECOM */
{USB_DEVICE(0x0411, 0x0242), .driver_info = RTL8821}, /* ELECOM - WDC-433DU2H */
{USB_DEVICE(0x2019, 0xAB32), .driver_info = RTL8821}, /* Planex - GW-450S */
{USB_DEVICE(0x0846, 0x9052), .driver_info = RTL8821}, /* Netgear - A6100 */
{USB_DEVICE(0x0411, 0x029B), .driver_info = RTL8821}, /* Buffalo - WI-U2-433DHP */
{USB_DEVICE(0x056E, 0x4007), .driver_info = RTL8821}, /* Elecom - WDC-433DU2HBK */
{USB_DEVICE(0x3823, 0x6249), .driver_info = RTL8821}, /* Obihai - OBiWiFi */
{USB_DEVICE(0x2357, 0x011E), .driver_info = RTL8821}, /* TP Link - T2U Nano */
{USB_DEVICE(0x2357, 0x011F), .driver_info = RTL8821}, /* TP Link - T2U */
{USB_DEVICE(0x2357, 0x0122), .driver_info = RTL8821}, /* TP Link - T2U Nano */
{USB_DEVICE(0x2357, 0x0120), .driver_info = RTL8821}, /* TP Link - T2U Plus */
*=== CONFIG_RTL8814A ===*
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8813), .driver_info = RTL8814A},
{USB_DEVICE(0x2001, 0x331A), .driver_info = RTL8814A}, /* D-Link - D-Link */
{USB_DEVICE(0x0B05, 0x1817), .driver_info = RTL8814A}, /* ASUS - ASUSTeK */
{USB_DEVICE(0x0B05, 0x1852), .driver_info = RTL8814A}, /* ASUS - ASUSTeK */
{USB_DEVICE(0x0B05, 0x1853), .driver_info = RTL8814A}, /* ASUS - ASUSTeK */
{USB_DEVICE(0x056E, 0x400B), .driver_info = RTL8814A}, /* ELECOM - ELECOM */
{USB_DEVICE(0x056E, 0x400D), .driver_info = RTL8814A}, /* ELECOM - ELECOM */
{USB_DEVICE(0x7392, 0xA834), .driver_info = RTL8814A}, /* Edimax - Edimax */
{USB_DEVICE(0x7392, 0xA833), .driver_info = RTL8814A}, /* Edimax - AC1750 */
{USB_DEVICE(0x0BDA, 0x8813), .driver_info = RTL8814A}, /* Edimax - EDUP Adapters */
{USB_DEVICE(0x2357, 0x0106), .driver_info = RTL8814A}, /* TP-LINK Archer T9UH */
{USB_DEVICE(0x20F4, 0x809A), .driver_info = RTL8814A}, /* TRENDnet - TRENDnet */
{USB_DEVICE(0x20F4, 0x809B), .driver_info = RTL8814A}, /* TRENDnet TEW-809UB */
{USB_DEVICE(0x0846, 0x9054), .driver_info = RTL8814A}, /* Netgear A7000 */

%prep
%setup -qn %{pname}-%{bversion}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}/lib/firmware
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a . %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
#%__mv -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/regdb/* %{buildroot}/lib/firmware/
%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{CONTRIBUTORS.md,LICENSE,README.md}
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME[0]="rtl%{module}"
BUILT_MODULE_LOCATION[0]="./"
MAKE="'make' SKIP_STACK_VALIDATION=1 all"
CLEAN="'make' clean"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/%{pname}"
AUTOINSTALL="yes"
EOF

# add rtl88xxau.conf in /etc/modprobe.d
mkdir -p %{buildroot}/etc/modprobe.d
cat <<EOF > %{buildroot}/etc/modprobe.d/rtl88xxau.conf
blacklist 8811au
blacklist 8812au
blacklist 8814au
blacklist 8821au
blacklist rtl8811au
blacklist rtl8812au
blacklist rtl8814au
blacklist rtl8821au
EOF

%post -n %{name}
rmmod 8811au >/dev/null 2>&1
rmmod 8812au >/dev/null 2>&1
rmmod 8814au >/dev/null 2>&1
rmmod 8821au >/dev/null 2>&1
rmmod rtl8811au >/dev/null 2>&1
rmmod rtl8812au >/dev/null 2>&1
rmmod rtl8814au >/dev/null 2>&1
rmmod rtl8821au >/dev/null 2>&1
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}

if [ "$1" = 1 ]; then
/sbin/modprobe %{pname} >/dev/null 2>&1
if [ -f /etc/NetworkManager/NetworkManager.conf ]; then
randmacad=`grep "wifi.scan-rand-mac-address=no" /etc/NetworkManager/NetworkManager.conf`
if [ "$randmacad" = z ]; then
echo "
[device]
wifi.scan-rand-mac-address=no
" >> /etc/NetworkManager/NetworkManager.conf
fi
fi
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
echo "%{pname}" >> /etc/modprobe.preload
fi

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
sed -i '/%{pname}/ d' /etc/modprobe.preload
fi
## remove module-destdir just if it empty after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/%{pname} >/dev/null 2>&1
fi

%clean
%__rm -rf %{buildroot}

%files
%doc README.md ReleaseNotes.pdf LICENSE
##CONTRIBUTORS.md LICENSE 
%defattr(-,root,root)
%{_usrsrc}/%{pname}-%{version}-%{release}
/etc/modprobe.d/rtl88xxau.conf
#/lib/firmware/*


%changelog
* Fri Feb 19 2021 tex - 5.7.0-7pclos2021
- apply kernel 5.10 patch

* Thu Aug 27 2020 onkelho <oh.quait at gmail.com> - 5.7.0-6pclos2020
- rebuild, add /etc/modprobe.d/rtl88xxau.conf

* Thu Aug 20 2020 onkelho <oh.quait at gmail.com> - 5.7.0-5pclos2020
- rebuild - rebase source-version to 5.6.4.2

* Mon May 25 2020 onkelho <oh.quait at gmail.com> - 5.7.0-4pclos2020
- rebuild,
- Fix kernel hang with active keepalive disabled
- Remove WINDOWS support + Cleanup source
- OpenWrt build define RTW_SINGLE_WIPHY

* Mon May 04 2020 onkelho <oh.quait at gmail.com> -5.7.0-3pclos2020
- rebuild
- better fix kernel-5.6... Patch2
- add Archer T2U

* Thu Apr 09 2020 onkelho <oh.quait at gmail.com> -5.7.0-2pclos2020
- rebuild fix kernel-5.6...
- use edited patch from rtl8821ce

* Sun Mar 22 2020 onkelho <oh.quait at gmail.com> - 5.7.0-1pclos2020
- new version released
- 8814au and 8821au has got a update, about time
- it's a closer fit to the 8812au and it's code now.
- AP mode had 30 sec. disconnect issue, that's fixed.
- Fix some AUTOSUSPEND and EARLY_SUSPEND issues
- Some cleanup of unused code.
- Some other minors all over ..
- The 8814au and 8821au is handling/performing netter now

